Codeforces 1005F Berland and the Shortest Paths

版权声明:转载请说明出处 https://blog.csdn.net/bao___zi/article/details/81751034

There are n cities in Berland. Some pairs of cities are connected by roads. All roads are bidirectional. Each road connects two different cities. There is at most one road between a pair of cities. The cities are numbered from 1 to n.

It is known that, from the capital (the city with the number 1), you can reach any other city by moving along the roads.

The President of Berland plans to improve the country's road network. The budget is enough to repair exactly n−1 roads. The President plans to choose a set of n−1 roads such that:

it is possible to travel from the capital to any other city along the n−1 chosen roads,

if di is the number of roads needed to travel from the capital to city i, moving only along the n−1 chosen roads, then d1+d2+⋯+dn is minimized (i.e. as minimal as possible).

In other words, the set of n−1 roads should preserve the connectivity of the country, and the sum of distances from city 1 to all cities should be minimized (where you can only use the n−1 chosen roads).

The president instructed the ministry to prepare k possible options to choose n−1 roads so that both conditions above are met.

Write a program that will find k possible ways to choose roads for repair. If there are fewer than k ways, then the program should output all possible valid ways to choose roads.

Input

The first line of the input contains integers n, m and k (2≤n≤2⋅10^5,n−1≤m≤2⋅10^5,1≤k≤2⋅10^5), where n is the number of cities in the country, m is the number of roads and k is the number of options to choose a set of roads for repair. It is guaranteed that m⋅k≤10^6.

The following m lines describe the roads, one road per line. Each line contains two integers ai, bi (1≤ai,bi≤n, ai≠bi) — the numbers of the cities that the i-th road connects. There is at most one road between a pair of cities. The given set of roads is such that you can reach any city from the capital.

Output

Print t (1≤t≤k) — the number of ways to choose a set of roads for repair. Recall that you need to find k different options; if there are fewer than k of them, then you need to find all possible different valid options.

In the following t lines, print the options, one per line. Print an option as a string of m characters where the j-th character is equal to '1' if the j-th road is included in the option, and is equal to '0' if the road is not included. The roads should be numbered according to their order in the input. The options can be printed in any order. All the t lines should be different.Since it is guaranteed that m⋅k≤10^6, the total length of all the t lines will not exceed 10^6.

If there are several answers, output any of them.

Examples

Input

4 4 3
1 2
2 3
1 4
4 3

Output

2
1110
1011

Input

4 6 3
1 2
2 3
1 4
4 3
2 4
1 3

Output

1
101001

Input

5 6 2
1 2
1 3
2 4
2 5
3 4
3 5

Output

2
111100
110110

题意:给你一个图,有n个节点m条边,然后让你选n-1条边,构造最小生成树,求最多k种构造方法。

解题:先用bfs求其他节点到1节点的最短距离,那么我们就可以知道其他节点到根有多少条相同距离的边。

然后我就暴力深搜一下,然后求最多k种方法。

#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<vector>
#include<queue>
#include<string>
#include<iostream>
using namespace std;
const int maxn=2e5+10;
const int inf=0x3f3f3f3f;
int n,m,dis[maxn],k;
vector<pair<int,int> > edge[maxn];
vector<int> to1[maxn];
void add(int u,int v,int i){
	edge[u].push_back(make_pair(v,i));
	edge[v].push_back(make_pair(u,i));
}
void bfs(){
	int i,j;
	for(i=1;i<=n;i++) dis[i]=inf;
	dis[1]=0;
	queue<int> qu;
	while(!qu.empty()) qu.pop();
	qu.push(1);
	while(!qu.empty()){
		int u=qu.front();qu.pop();
		for(i=0;i<edge[u].size();i++){
			int v=edge[u][i].first;
			if(dis[u]+1<dis[v]){
				dis[v]=dis[u]+1;
				qu.push(v);
			}
		}
	}
	return ;
}
char res[maxn];
vector<string> ans; 
void dfs(int u){
	if(ans.size()>k) return ;
	if(u==n+1){
		ans.push_back(res+1);
		return ;
	} 
	for(int i=0;i<to1[u].size();i++){
		int s=to1[u][i];
		res[s]='1';
		dfs(u+1);
		res[s]='0';
	} 
}
void solve(){
	int i,j,u,v;
	for(i=1;i<=m;i++){
		scanf("%d%d",&u,&v);
		add(u,v,i);
	}
	bfs();
	for(i=2;i<=n;i++){
		for(j=0;j<edge[i].size();j++){
			int v=edge[i][j].first;
			if(dis[i]==dis[v]+1){
				to1[i].push_back(edge[i][j].second);
			}
		}
	}
	for(i=1;i<=m;i++) res[i]='0';
	dfs(2);
	int len=ans.size();
	len=min(len,k);
	printf("%d\n",len);
	for(i=0;i<len;i++){
		cout<<ans[i]<<endl;
	}
}
int main(){
	int i,j;
	scanf("%d%d%d",&n,&m,&k);
	solve();
	return 0;
}

猜你喜欢

转载自blog.csdn.net/bao___zi/article/details/81751034